import { JSONSchemaType } from 'ajv';
import { AppConfig, AppConfigLeaf, Env, ConfigConfig, mergeByPriority } from './base';
export { AppConfig, AppConfigLeaf, Env, ConfigConfig, mergeByPriority };
import * as loader from './loaders';
export { loader };
export declare const configEval: (configConfig: ConfigConfig | ConfigConfig[]) => Promise<AppConfigLeaf>;
export type ConfigSystemSchema<T> = Omit<JSONSchemaType<T>, 'type'>;
export type LoadConfigArgs = {
    defaultConfig?: AppConfigLeaf;
    configDir?: string;
    verbose?: boolean;
    env?: Env;
    schema?: ConfigSystemSchema<Object>;
};
export declare const loadConfig: <CONFIG extends AppConfig>(argOpts: LoadConfigArgs) => Promise<CONFIG>;
export declare const loadConfigCached: <CONFIG extends AppConfig>(args: LoadConfigArgs) => Promise<CONFIG>;
